<?php

namespace Teknisa\DF\Modules\Entrada\SincronizacaoNFSe;

use Teknisa\DF\Modules\Entrada\SincronizacaoNFSe\Utilities\Util;
use Teknisa\Libs\Util\Environment;
use Teknisa\DF\Modules\Entrada\SincronizacaoNFSe\Utilities\SyncNFSe as SyncNFSe;
use Teknisa\DF\Services\NFSe\NFSe;


class ConsultaNFSeSaoPaulo extends NFSe {
    
    public function __construct($importacaoConsultaNotaFiscalFactory, $row, $connection, Environment $environment, $newCode, $xmlDir, $certUploadDir = null, $certUploadLink = null, $certKeyLink = null) {
        $this->cdempresa  = $row["CDEMPRESA"];
        $this->CPFCNPJRemetente = $row["NRINSJUREMPR"];
        $this->inscricaoMunicipalTomador = str_replace(".","",$row["CDINSCMUNI"]); 
        $this->inscricaoMunicipalTomador = str_replace("-","", $this->inscricaoMunicipalTomador); 
        $this->cdinscmuni = $row["CDINSCMUNI"];
        $this->connection = $connection;
        $this->environment = $environment;
        $this->numeroPagina = 1;
        $this->NotasServico = array();
        $this->dataInicio = $row["DTINICIO"];
        $this->dataFim= $row["DTFIM"];
        $this->dfe51000ImportacaoConsultaNotaFiscalFactory = $importacaoConsultaNotaFiscalFactory; 
        if($certUploadDir) {
            $this->setCaminhoCertificado($certUploadDir);
        }
        else {
            $this->linkCertificado = $certUploadLink;
            $this->linkCertKey     = $certKeyLink;
        }
        
        if($this->environment->getNrOrgTrab() == 1) {
            $this->SAAS = false;
        }
        else {
            $this->SAAS = true;
        }
        
	}
	public function setTagsXml($arrayXml) {
        $this->ide              = $arrayXml;
	    $this->nrAcessoNfe      = $arrayXml["ChaveNFe"]["NumeroNFe"];
	    $this->CodigoVerificacao= $arrayXml["ChaveNFe"]["CodigoVerificacao"];
	    $this->emitente         = $arrayXml["CPFCNPJPrestador"];
	    $this->destinatario     = $arrayXml["CPFCNPJTomador"];
	    $this->ValorServicos    = Util::fomataValor($arrayXml["ValorServicos"], -2 , '.');
        $this->ValorDeducoes    = Util::fomataValor($arrayXml["ValorDeducoes"], -2 , '.');
        $this->ValorPIS         = $arrayXml["ValorPIS"];
        $this->ValorCOFINS      = $arrayXml["ValorCOFINS"];
        $this->ValorINSS        = $arrayXml["ValorINSS"];
        $this->ValorIR          = $arrayXml["ValorIR"];
        $this->ValorCSLL        = $arrayXml["ValorCSLL"];
        $this->CodigoServico    = $arrayXml["CodigoServico"];
        $this->AliquotaServicos = $arrayXml["AliquotaServicos"]; 
        $this->ValorISS         = $arrayXml["ValorISS"];
        $this->ValorCredito     = $arrayXml["ValorCredito"];
        $this->ISSRetido        = $arrayXml["ISSRetido"];
        $this->Discriminacao    = $arrayXml["Discriminacao"];
        $this->EmailTomador     = $arrayXml["EmailTomador"];
        $this->dataEmissaoNFe   = $arrayXml["DataEmissaoNFe"];
        $this->NumeroRPS        = $arrayXml["ChaveRPS"]["NumeroRPS"];
        $this->SerieRPS         = $arrayXml["ChaveRPS"]["SerieRPS"];
      
    } 
    public function createSoapText($conteudo, $nomeFuncao) {
        $tagRequest = "ConsultaNFeRecebidasRequest";
       
        $mensagemSoap= '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:nfe="http://www.prefeitura.sp.gov.br/nfe">'
            .'<soapenv:Header/>'
            	 .'<soapenv:Body>'
            		  .'<nfe:'.$tagRequest.'>'
            		    . '<nfe:VersaoSchema>1</nfe:VersaoSchema>';
 		$mensagemSoap .= '<nfe:MensagemXML>
            			 '.$conteudo.'</nfe:MensagemXML>'
            	     .'</nfe:'.$tagRequest.'>'
            	 .'</soapenv:Body>'
         .'</soapenv:Envelope>';
        
        return $mensagemSoap;

    }
    public function lerXMl($resultado){
            $notas = 0;
            $xml = simplexml_load_string($resultado);
            if($xml->Cabecalho->Sucesso != 'false'){
                foreach($xml->NFe as $nfe){ 
                    array_push($this->NotasServico,  $nfe);
                    $notas++;
                }  
                return $notas;
            }else{
                throw new \Exception($xml->Erro->Descricao);
            }
    }
    public function getNotas(){
    while($this->FimPaginas){
            $this->xmlConsultaLotePeriodo();
            try {

                $xml = $this->getXmlAssinadoConsultaLoteRps($this->cdempresa, $this->cdinscmuni);
                $result = $this->enviarParaWebservice( "ConsultaNFeRecebidasRequest" , $xml);
                //$result = $this->xmlteste;
                $notasResposta = $this->lerXml($result);
                 if($notasResposta < 50){
                    $this->FimPaginas = false; 
                 }
                $this->numeroPagina++;
            }catch(\Exception $e) {
                throw $e;
            }
       } 
       return $this->NotasServico;
    }
    
    private function getXmlAssinadoConsultaLoteRps($cdemploterps, $inscricaoMunicipalTomador ){
        $this->xmlConsultaLotePeriodo = str_replace("&", "&amp;", $this->xmlConsultaLotePeriodo);
        $domXml = new \DOMDocument("1.0", "UTF-8");
        $domXml->loadXML($this->xmlConsultaLotePeriodo, LIBXML_NOBLANKS);
        $domXml->formatOutput = false;
        $xmlTemp = $domXml->saveXML();
        
        $domXml = new \DOMDocument("1.0", "UTF-8");
        $domXml->loadXML($xmlTemp);
        $domXml->encoding = "UTF-8";
        $this->senhaCertificadoDigital = Util::getSenhaCertificadoDigital($this->connection, $cdemploterps, $inscricaoMunicipalTomador, $this->environment->getNrOrg());
        $domXml = $this->assinaXml($domXml, array("PedidoConsultaNFePeriodo"));
        if ($domXml === false) {
            throw new \Exception("Certificado digital não encontrado!");
        }
        else {
           return $domXml->saveXML($domXml->documentElement);
        }
        
        
    }
    private function xmlConsultaLotePeriodo(){
        $this->xmlConsultaLotePeriodo = 
        '<PedidoConsultaNFePeriodo xmlns="http://www.prefeitura.sp.gov.br/nfe">'
            .'<Cabecalho xmlns="" Versao="1">'
                .'<CPFCNPJRemetente>';
                	if (strlen($this->CPFCNPJRemetente) == 11) {
    					$this->xmlConsultaLotePeriodo .='<CPF>'.$this->CPFCNPJRemetente.'<CPF>';
    				}
    				else {
    					$this->xmlConsultaLotePeriodo .= '<CNPJ>'.$this->CPFCNPJRemetente.'</CNPJ>';
    				}
    				$this->xmlConsultaLotePeriodo .=  '</CPFCNPJRemetente>'
                 .'<CPFCNPJ>';
                	if (strlen($this->CPFCNPJRemetente) == 11) {
    					$this->xmlConsultaLotePeriodo .='<CPF>'.$this->CPFCNPJRemetente.'<CPF>';
    				}
    				else {
    					$this->xmlConsultaLotePeriodo .= '<CNPJ>'.$this->CPFCNPJRemetente.'</CNPJ>';
    				}
    				$this->xmlConsultaLotePeriodo .=  '</CPFCNPJ>';
    				
    				if($this->inscricaoMunicipalTomador != 'ISENTA' && $this->inscricaoMunicipalTomador != 'ISENTO'){
                    $this->xmlConsultaLotePeriodo .='<Inscricao>'.$this->inscricaoMunicipalTomador.'</Inscricao>';
                    }
                	$this->xmlConsultaLotePeriodo .='<dtInicio>'.$this->dataInicio.'</dtInicio>'
                .'<dtFim>'.$this->dataFim.'</dtFim>'
                .'<NumeroPagina>'.$this->numeroPagina.'</NumeroPagina>'
            .'</Cabecalho>'
            .'</PedidoConsultaNFePeriodo>';
    }

    
    
    
    

}