<?php
namespace Teknisa\DF\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class Dfe26000InflacaoInterna {

	protected $reportService;
    protected $Dfe26000InflacaoInternaService;

	public function __construct($reportService, $Dfe26000InflacaoInternaService) {
		$this->reportService = $reportService;
        $this->Dfe26000InflacaoInternaService = $Dfe26000InflacaoInternaService;
	}

	public function GeraRelat(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        if($row['REPORT_NAME'] == 'DFE26000'){

            $parameterMapping = array(
                "TIPOCUSTO" => "TIPOCUSTO",
                "NMTIPOCUSTO" => "NMTIPOCUSTO",
                "CDOPERENTR" => "CDOPERENTR",
                "CDPRODFINAL" => "CDPRODFINAL",
                "CDFILIAL" => "CDFILIAL",
                "DATAINICIAL" => "DATAINICIAL",
                "DATAFINAL" => "DATAFINAL",
                "CDPRODINI" => "CDPRODINI",
                "TAMNIVEL" => "TAMNIVEL"
                );

            try{
                $dadosParaRelatorio = $this->Dfe26000InflacaoInternaService->buildParametersByRelatorio($row, $parameterMapping);
                $reportName = $dadosParaRelatorio['ReportName'];
                $parametersRow = $dadosParaRelatorio['ParametersRow'];
                $birtURL =$this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
                $response->addDataset(new DataSet('URL',array($birtURL)));
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage() , 500));
            }

        } else if($row['REPORT_NAME'] == 'DFE26001'){
            $parameterMapping = array(
                "INIMES1" => "INIMES1",
                "INIMES2" => "INIMES2",
                "FINMES1" => "FINMES1",
                "FINMES2" => "FINMES2",
                "CDOPERENTR" => "CDOPERENTR",
                "CDFILIAL" => "CDFILIAL",
                "CDPRODINI" => "CDPRODINI",
                "CDPRODFINAL" => "CDPRODFINAL",
                "TAMNIVEL" => "TAMNIVEL"
                );

            try{
                $dadosParaRelatorio = $this->Dfe26000InflacaoInternaService->buildParametersByRelatorio($row, $parameterMapping);
                $reportName = $dadosParaRelatorio['ReportName'];
                $parametersRow = $dadosParaRelatorio['ParametersRow'];
	    		$birtURL =$this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
	        	$response->addDataset(new DataSet('URL',array($birtURL)));
	        } catch (\Exception $e) {
	        	$response->setError(new Error($e->getMessage() , 500));
	        }

    	} else if($row['REPORT_NAME'] == 'DFE26002'){
            $parameterMapping = array(
                "INIMES1" => "INIMES1",
                "INIMES2" => "INIMES2",
                "FINMES1" => "FINMES1",
                "FINMES2" => "FINMES2",
                "CDOPERENTR" => "CDOPERENTR",
                "CDFILIAL" => "CDFILIAL",
                "CDPRODINI" => "CDPRODINI",
                "CDPRODFINAL" => "CDPRODFINAL",
                "TAMNIVEL" => "TAMNIVEL"
                );

            try{
                $dadosParaRelatorio = $this->Dfe26000InflacaoInternaService->buildParametersByRelatorio($row, $parameterMapping);
                $reportName = $dadosParaRelatorio['ReportName'];
                $parametersRow = $dadosParaRelatorio['ParametersRow'];
				$birtURL =$this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
	        	$response->addDataset(new DataSet('URL',array($birtURL)));
	        } catch (\Exception $e) {
	        	$response->setError(new Error($e->getMessage() , 500));
	        }

    	}else if($row['REPORT_NAME'] == 'DFE26000_Consolidada'){

            $parameterMapping = array(
                "TIPOCUSTO" => "TIPOCUSTO",
                "NMTIPOCUSTO" => "NMTIPOCUSTO",
                "CDOPERENTR" => "CDOPERENTR",
                "CDPRODFINAL" => "CDPRODFINAL",
                "CDGRUPFILI" => "CDGRUPFILI",
                "DATAINICIAL" => "DATAINICIAL",
                "DATAFINAL" => "DATAFINAL",
                "CDPRODINI" => "CDPRODINI",
                "TAMNIVEL" => "TAMNIVEL"
                );

            try{ 
                     
                     
                $dadosParaRelatorio = $this->Dfe26000InflacaoInternaService->buildParametersByRelatorio($row, $parameterMapping);
                $reportName = $dadosParaRelatorio['ReportName'];
                $parametersRow = $dadosParaRelatorio['ParametersRow'];
                $parametersRow['__format'] = "xlsx";
                $birtURL =$this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
                $response->addDataset(new DataSet('URL',array($birtURL)));
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage() , 500));
            }

        }else {
    		$response->setError(new Error('Erro ao encontrar o relatório', 500));
    		$chamaRelatorio = false;
    	}
    }
    
    
}